
package org.oransc.nonrtric.plt.capifcore.exception;

import org.oransc.capif.model.ProblemDetails;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.context.request.WebRequest;
import org.springframework.web.server.ResponseStatusException;
import org.springframework.web.servlet.mvc.method.annotation.ResponseEntityExceptionHandler;

@ControllerAdvice
public class RestResponseEntityExceptionHandler extends ResponseEntityExceptionHandler {

    @ExceptionHandler(value = {ResponseStatusException.class})
    protected ResponseEntity<Object> handleConflict(ResponseStatusException ex, WebRequest request) {
        ProblemDetails bodyOfResponse = new ProblemDetails();
        bodyOfResponse.cause(ex.getReason());
        bodyOfResponse.status(ex.getStatus().value());
        HttpHeaders headers = new HttpHeaders();
        headers.setContentType(MediaType.APPLICATION_PROBLEM_JSON);
        return handleExceptionInternal(ex, bodyOfResponse, headers, ex.getStatus(), request);
    }
}
